# std::stack< Type, Sequence > Class Template Reference
[Containers, Sequences]

A standard container giving FILO behavior. More...

`#include <stl_stack.h>`

List of all members.

## Public Member Functions
| stack (const Sequence &c=Sequence())
| Default constructor creates no elements.
bool | empty () const
size_type | size () const
reference | top ()
const_reference | top () const
void | push (const value_type &x)
| Add data to the top of the stack.
void | pop ()
| Removes first element.

## Detailed Description

### template<typename Type, typename Sequence>
class std::stack< Type, Sequence >

A standard container giving FILO behavior.

Meets many of the requirements of a container, but does not define anything to do with iterators. Very few of the other standard container interfaces are defined.

This is not a true container, but an adaptor. It holds another container, and provides a wrapper interface to that container. The wrapper is what enforces strict first-in-last-out stack behavior.

The second template parameter defines the type of the underlying sequence/container. It defaults to std::deque, but it can be any type that supports `back`, `push_back`, and `pop_front`, such as std::list, std::vector, or an appropriate user-defined type.

Members not found in "normal" containers are `container_type`, which is a typedef for the second Sequence parameter, and `push`, `pop`, and `top`, which are standard stack/FILO operations.

Definition at line 110 of file stl_stack.h.

## Constructor & Destructor Documentation

template<typename Type, typename Sequence>
std::stack< Type, Sequence >::stack | ( | const Sequence & | c = `Sequence()` | ) | `[inline, explicit]`

| Default constructor creates no elements. Definition at line 143 of file stl_stack.h.

## Member Function Documentation

template<typename Type, typename Sequence>
bool std::stack< Type, Sequence >::empty | ( |  | ) | const`[inline]`

| Returns true if the stack is empty. Definition at line 150 of file stl_stack.h.

template<typename Type, typename Sequence>
void std::stack< Type, Sequence >::pop | ( |  | ) | `[inline]`

| Removes first element. This is a typical stack operation. It shrinks the stack by one. The time complexity of the operation depends on the underlying sequence. Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop() is called. Definition at line 205 of file stl_stack.h.

template<typename Type, typename Sequence>
void std::stack< Type, Sequence >::push | ( | const value_type & | x | ) | `[inline]`

  | Add data to the top of the stack. Parameters:
  | x | Data to be added.
This is a typical stack operation. The function creates an element at the top of the stack and assigns the given data to it. The time complexity of the operation depends on the underlying sequence. Definition at line 190 of file stl_stack.h. References std::stack< Type, Sequence >::push(). Referenced by std::stack< Type, Sequence >::push().

template<typename Type, typename Sequence>
size_type std::stack< Type, Sequence >::size | ( |  | ) | const`[inline]`

| Returns the number of elements in the stack. Definition at line 155 of file stl_stack.h.

template<typename Type, typename Sequence>
const_reference std::stack< Type, Sequence >::top | ( |  | ) | const`[inline]`

| Returns a read-only (constant) reference to the data at the first element of the stack. Definition at line 174 of file stl_stack.h.

template<typename Type, typename Sequence>
reference std::stack< Type, Sequence >::top | ( |  | ) | `[inline]`

| Returns a read/write reference to the data at the first element of the stack. Definition at line 163 of file stl_stack.h.

The documentation for this class was generated from the following file:

- stl_stack.h